--==========================================================
-- Design units :
--
-- File name    :
--
-- Purpose      :
--
-- Limitations  :
--
-- Library      :
--
-- Dependencies :
--
-- Author       : Claus-Juergen Thomas, REFT
--
-- Simulator    : Synopsys V3.1a on SUN SPARCstation 10
--
-----------------------------------------------------------
-- Revision list
-- Version Author Date           Changes
--
--
--=========================================================

LIBRARY IEEE;
USE IEEE.std_logic_1164.all;
USE work.ELEMpack.all;
USE work.CarryLookaheadPackage.all;

ENTITY CLA_Testbench IS
END CLA_Testbench;

--============================ARCHITECTURE==================

ARCHITECTURE Structure OF CLA_Testbench IS

CONSTANT M: POSITIVE := 24;
SIGNAL A,B,S: std_logic_vector(M-1 DOWNTO 0);
SIGNAL CarryIn,CarryOut: std_logic;

BEGIN

  MUT : Carry_Lookahead_Adder
    GENERIC MAP(M)
    PORT MAP(A,B,CarryIn,S,CarryOut);

A <= "000000000000000000000000" AFTER 0 Ns,
     "001001001010101101000001" AFTER 100 Ns,
     "010100101010101010000010" AFTER 200 Ns,
     "010011101011010110000011" AFTER 300 Ns,
     "010111010101011110000100" AFTER 400 Ns,
     "111111111111111111111111" AFTER 500 Ns,
     "000000000000000000000000" AFTER 600 Ns,
     "000000000000000000000111" AFTER 700 Ns;
  

B <= "000000000000000000000000" AFTER 0 Ns,
     "000010011100110101100001" AFTER 100 Ns,
     "000011110111101011110010" AFTER 200 Ns,
     "001110010000010010000011" AFTER 300 Ns,
     "000000000000000000000100" AFTER 400 Ns,
     "000000000000000000000001" AFTER 500 Ns,
     "000000000000000000000000" AFTER 600 Ns,
     "011101110101000010000111" AFTER 700 Ns;
 


CarryIn <= '0' AFTER 0 Ns,
           '1' AFTER 400 Ns;

END Structure;

--============================CONFIGURATION=================

CONFIGURATION CLA_Testbench_Config OF CLA_Testbench IS

  FOR Structure

    FOR MUT :  Carry_Lookahead_Adder
      USE ENTITY work. Carry_Lookahead_Adder(Structure);
    END FOR;

  END FOR;

END CLA_Testbench_Config;